[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.8 and 1.95

version 1.8, 2021/10/16 19:31:13 version 1.95, 2021/12/21 02:16:47
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  #       $OpenBSD$
   #
   # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
   #
   # Permission to use, copy, modify, and distribute this software for any
   # purpose with or without fee is hereby granted, provided that the above
   # copyright notice and this permission notice appear in all copies.
   #
   # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
   # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
   # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
   # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
   # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
   # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 scan_dmesg() {  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
         # no bsort for now  set +o monitor
         sed -n "$1" /var/run/dmesg.boot  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
 }  
   
 installed_firmware() {  CFILE=SHA256.sig
         for fw in ${PKGDIR}/$1-firmware*; do  DESTDIR=${DESTDIR:-}
                 [ -e "$fw" ] || continue  FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                 echo ${fw##*/}  
         done  
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
   VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 # Create a temporary directory based on the supplied directory name prefix.  HTTP_FWDIR="$VNAME"
   VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
   [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
   FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
   FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
   
   DOWNLOAD=true
   INSTALL=true
   LOCALSRC=
   
 tmpdir() {  tmpdir() {
         local _i=1 _dir          local _i=1 _dir
   
         until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do          # If we're not in the installer,
                 ((++_i < 10000)) || return 1          # we have mktemp and a more hostile environment.
         done          if [ -x /usr/bin/mktemp ]; then
                   _dir=$( mktemp -d "${1}-XXXXXXXXX" )
           else
                   until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
                       ((++_i < 10000)) || return 1
                   done
           fi
   
         echo "$_dir"          echo "$_dir"
 }  }
   
 # Run a command ($2+) as unprivileged user ($1).  fetch() {
 # Take extra care that after "cmd" no "user" processes exist.          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
 #  
 # Optionally:  
 #       - create "file" and chown it to "user"  
 #       - after "cmd", chown "file" back to root  
 #  
 # Usage: do_as user [-f file] cmd  
 do_as() {  
         (( $# >= 2 )) || return  
   
         local _file _rc _user=$1          # If we're not in the installer,
         shift          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
           if [ -x /usr/bin/su ]; then
                   exec /usr/bin/su -s /bin/ksh "$_user" -c \
                       "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
           else
                   exec /usr/bin/doas -u "$_user" \
                       /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
           fi
           ) & _pid=$!
           set +o monitor
   
         if [[ $1 == -f ]]; then          trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
                 _file=$2  
                 shift 2          SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   _error=" (timed out)"
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
           if [ "$_exit" -ne 0 ]; then
                   rm -f "$_dst"
                   echo "Cannot fetch $_src$_error" >&2
                   return 1
         fi          fi
   }
   
         if [[ -n $_file ]]; then  verify() {
                 >$_file          # On the installer we don't get sha256 -C, so fake it.
                 chown "$_user" "$_file"          if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                   echo "Checksum test for ${1##*/} failed." >&2
                   return 1
         fi          fi
   }
   
         doas -u "$_user" "$@"  devices_needing_firmware() {
         _rc=$?          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         while doas -u "$_user" kill -9 -1 2>/dev/null; do          # When we're not in the installer, the dmesg.boot can
                 echo "Processes still running for user $_user after: $@"          # contain multiple boots, so only look in the last one
                 sleep 1          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
         done              grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
   
         [[ -n $_file ]] && chown root "$_file"          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
               while read -r _d _m; do
                   [ "$_d" = "$_last" ] && continue
                   [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
         return $_rc                  if [[ $_dmesgtail = *$_m* ]]; then
                           echo "$_d"
                           _last="$_d"
                   fi
               done
 }  }
   
 unpriv() {  firmware_filename() {
         do_as _sndio "$@"          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
 unpriv2() {  firmware_devicename() {
         do_as _file "$@"          local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
 }  }
   
 _issue=  installed_firmware() {
 fail() {          set +o noglob
         echo $_issue >&2          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
         exit 1                  [ -e "$fw" ] || continue
                   echo "${fw##*/}"
           done
           set -o noglob
 }  }
   
 VNAME=$(sysctl -n kern.osrelease)  add_firmware () {
 VERSION="${VNAME%.*}${VNAME#*.}"          local _f="${1##*/}"
 FWDIR="$VNAME"          local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
           ftp -D "Install" -Vmo- "file:${1}" |
                   tar -s ",^\+,${_pkgdir}/+," \
                       -s ",^firmware,${DESTDIR}/etc/firmware," \
                       -C / -zxphf - "+*" "firmware/*"
   
 HTTP_FWDIR=$FWDIR          # TODO: Should we mark these so real fw_update can -Drepair?
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")          ed -s "${_pkgdir}/+CONTENTS" <<EOL
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  /^@comment pkgpath/ -1a
   @option manual-installation
   @option firmware
   @comment install-script
   .
   w
   EOL
   }
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  delete_firmware() {
 FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub          local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
 PKGDIR=${DESTDIR}/var/db/pkg  
 PATTERNS="file:${0%/*}/firmware_patterns"  
   
 drivers=$(          # TODO: Check hash for files before deleting
         last=''          echo "Uninstalling $_pkg"
         ftp -D "Detecting" -Vmo- $PATTERNS |          _cwd="${_pkgdir}/$_pkg"
         while read d m; do  
                 grep=grep          set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
                 [ "$last" = "$d" ] && continue  
                 [ "$m" ] || m="^$d[0-9][0-9]* at "          while read -r c g; do
                 [ "$m" = "${m#^}" ] && grep=fgrep                  case $c in
                 $grep -q "$m" /var/run/dmesg.boot || continue                  @cwd) _cwd="${DESTDIR}$g"
                 echo $d                    ;;
                 last=$d                  @*) continue
                     ;;
                   *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                     ;;
                   esac
           done < "${_pkgdir}/${_pkg}/+CONTENTS"
   
           # We specifically rm -f here because not removing files/dirs
           # is probably not worth failing over.
           for _r in "${_remove[@]}" ; do
                   if [ -d "$_r" ]; then
                           # Try hard not to actually remove recursively
                           # without rmdir on the install media.
                           set +o noglob
                           [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                   else
                           rm -f "$_r"
                   fi
         done          done
 )  }
   
 if [ -z "$drivers" ]; then  usage() {
         echo "No devices found which need firmware files to be downloaded." >&2          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
         exit 0          exit 2
 fi  }
   
 _src=$FWURL  OPT_D=
 if _tmpsrc=$( tmpdir "${DESTDIR}/tmp/fw_update" ); then  OPT_L=
         (  while getopts DL name
         >$_tmpsrc/t &&  do
         $_unpriv cat $_tmpsrc/t         case "$name" in
         ) >/dev/null 2>&1 ||         D) OPT_D=true ;;
             rm -r $_tmpsrc         L) OPT_L=true ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
   [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1
   
   if [ "$OPT_D" ]; then
           # "Download only" means local dir and don't install
           INSTALL=false
           LOCALSRC=.
   elif [ "$OPT_L" ]; then
           # "Local" means don't download, install from local dir
           DOWNLOAD=false
           LOCALSRC=.
   else
           LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
 fi  fi
   
 [[ ! -d $_tmpsrc ]] &&  CFILE="$LOCALSRC/$CFILE"
         _issue="Cannot create prefetch area" && fail  
   
 cd "$_tmpsrc"  if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
 _t=Get  set -A devices -- "$@"
 _cfile="$_tmpsrc/SHA256"  
 _srclocal=false  
   
 ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&  if [ ! "${devices[*]:-}" ]; then
     _issue="Cannot fetch SHA256.sig" && fail          echo -n "Detecting firmware ..."
           set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
   fi
   
 # Verify signature file with public keys.  [ "${devices[*]:-}" ] || exit
 ! unpriv -f "$_cfile" \  
     signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&  
     _issue="Signature check of SHA256.sig failed" && fail  
   
 for d in $drivers; do  if "$DOWNLOAD"; then
         _f=$( sed -n "s/.*(\($d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )          fetch "$CFILE"
         installed=$( installed_firmware "$d" )          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
         for i in $installed; do  for f in "${devices[@]}"; do
                 if [ "$_f" = "$i.tgz" ]; then          d="$( firmware_devicename "$f" )"
                         echo "Firmware for $d already installed ($installed)"  
                         continue 2  
                 fi  
         done  
   
         rm -f /tmp/h /tmp/fail          if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
                   f="$LOCALSRC/$f"
           elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                   echo "Cannot download local file $f" >&2
                   exit 2
           fi
   
         _t=Get/Verify          set -A installed -- $( installed_firmware "$d" )
         # Fetch firmware file and create a checksum by piping through  
         # sha256. Create a flag file in case ftp failed. Firmware  
         # from net is written to the prefetch area.  
         ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |  
         ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||  
             unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )  
   
         # Handle failed transfer.          if "$INSTALL" && [ "${installed[*]:-}" ]; then
         if [[ -f /tmp/fail ]]; then                  for i in "${installed[@]}"; do
                 rm -f "$_tmpsrc/$_f"                          if [ "${f##*/}" = "$i.tgz" ]; then
                 _issue="Fetching of $_f failed!"                                  echo "$i already installed"
                 fail                                  continue 2
                           fi
                   done
         fi          fi
   
         # Verify firmware by comparing its checksum with SHA256.          if [ -e "$f" ]; then
         if fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then                  if "$DOWNLOAD"; then
                 #_unver=$(rmel $_f $_unver)                          echo "Verify existing ${f##*/}"
                 true                          verify "$f" || continue
         else                  # else assume it was verified when downloaded
                 [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"                  fi
                 _issue="Checksum test for $_f failed."          elif "$DOWNLOAD"; then
                 fail                  fetch  "$f" || continue
                   verify "$f" || continue
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
         fi          fi
   
         # TODO: Check hash for files before deleting          "$INSTALL" || continue
         if [ "$installed" ] && [ -e "${PKGDIR}/$installed/+CONTENTS" ]; then  
                 echo "Uninstalling $installed"  
                 cwd=${PKGDIR}/$installed  
   
                 remove="${cwd}/+CONTENTS ${cwd}"          if [ "${installed[*]:-}" ]; then
                   for i in "${installed[@]}"; do
                 while read c g; do                          delete_firmware "$i"
                         case $c in  
                         @cwd) cwd=$g  
                           ;;  
                         @*) continue  
                           ;;  
                         *)  remove="$cwd/$c $remove"  
                           ;;  
                         esac  
                 done < "${PKGDIR}/$installed/+CONTENTS"  
   
                 for r in $remove ; do  
                         if [ -d "$r" ]; then  
                                 # Try hard not to actually remove recursively  
                                 # without rmdir on the install media.  
                                 [ "$r/*" = $( echo "$r"/* ) ] && rm -rf "$r"  
                         else  
                                 rm -f "$r"  
                         fi  
                 done                  done
         fi          fi
   
         # TODO: Add some details about the install to +CONTENTS like pkg_add          add_firmware "$f"
         # TODO: Or, maybe we save the firmware someplace and make pkg_add reinstall  
         echo "Installing $_f"  
         tar -zxphf "$_f" -C /etc "firmware/*"  
         mkdir -p ${PKGDIR}/${firmware%.tgz}/  
         tar -zxphf "$_f" -C "${PKGDIR}/${firmware%.tgz}" "+*"  
         ed -s "${PKGDIR}/${firmware%.tgz}/+CONTENTS" <<EOL  
 /^@comment pkgpath/ -1a  
 @option manual-installation  
 @option firmware  
 @comment install-script  
 .  
 w  
 EOL  
 done  done
   

Legend:
Removed from v.1.8  
changed lines
  Added in v.1.95

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>